// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from foxglove_msgs:msg/CylinderMarker.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "foxglove_msgs/msg/cylinder_marker.h"


#ifndef FOXGLOVE_MSGS__MSG__DETAIL__CYLINDER_MARKER__STRUCT_H_
#define FOXGLOVE_MSGS__MSG__DETAIL__CYLINDER_MARKER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'frame_id'
// Member 'id'
#include "rosidl_runtime_c/string.h"
// Member 'lifetime'
#include "builtin_interfaces/msg/detail/duration__struct.h"
// Member 'metadata'
#include "foxglove_msgs/msg/detail/key_value_pair__struct.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'color'
#include "foxglove_msgs/msg/detail/color__struct.h"

/// Struct defined in msg/CylinderMarker in the package foxglove_msgs.
/**
  * foxglove_msgs/msg/CylinderMarker
  * A marker representing a cylinder or elliptic cylinder
 */
typedef struct foxglove_msgs__msg__CylinderMarker
{
  /// Generated by https://github.com/foxglove/schemas
  /// Timestamp of the marker
  builtin_interfaces__msg__Time timestamp;
  /// Frame of reference
  rosidl_runtime_c__String frame_id;
  /// Identifier for the marker. A marker will replace any prior marker on the same topic with the same `id`.
  rosidl_runtime_c__String id;
  /// Length of time (relative to `timestamp`) after which the marker should be automatically removed. Zero value indicates the marker should remain visible until it is replaced or deleted.
  builtin_interfaces__msg__Duration lifetime;
  /// Whether the marker should keep its location in the fixed frame (false) or follow the frame specified in `frame_id` as it moves relative to the fixed frame (true)
  bool frame_locked;
  /// Additional user-provided metadata associated with the marker. Keys must be unique.
  foxglove_msgs__msg__KeyValuePair__Sequence metadata;
  /// Position of the center of the cylinder and orientation of the cylinder. The cylinder's flat faces are perpendicular to the z-axis.
  geometry_msgs__msg__Pose pose;
  /// Radius of the cylinder at min z
  double bottom_radius;
  /// Radius of the cylinder at max z
  double top_radius;
  /// Height of the cylinder along the z axis
  double height;
  /// Color of the sphere
  foxglove_msgs__msg__Color color;
} foxglove_msgs__msg__CylinderMarker;

// Struct for a sequence of foxglove_msgs__msg__CylinderMarker.
typedef struct foxglove_msgs__msg__CylinderMarker__Sequence
{
  foxglove_msgs__msg__CylinderMarker * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} foxglove_msgs__msg__CylinderMarker__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // FOXGLOVE_MSGS__MSG__DETAIL__CYLINDER_MARKER__STRUCT_H_
